//****************************************************************************
// 1 bit binary add/sub.
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

module adder(Mode, Ain, Bin, Cin, Dout, Cout);

input Mode, Ain, Bin, Cin;
output Dout, Cout;

wire Mode, Ain, Bin, Cin;
wire Dout, Cout;

assign Dout = (Ain ^ (Mode ^ Bin)) ^ Cin;
assign Cout = (Ain & (Mode ^ Bin)) | (Ain & Cin) | ((Mode ^ Bin) & Cin);

endmodule
